/** @jsx React.DOM */
"use strict";

define('logging',
      ['common_util'],
      function(Util) {

  var g_log = [];
  function log(evt) {
    g_log.push(Date.now()); // timestamp
    g_log.push(evt);
  }

  function reportMetric(metric, value, properties) {
    Util.assert(typeof metric === 'string');
    var data = {metric: metric};
    if (value != null) {
      Util.assert(typeof value === 'number');
      data['value'] = String(value);
    }
    if (properties != null) {
      data['properties'] = JSON.stringify(properties);
    }
    data['_xsrf'] = Util.getCookie('_xsrf');
    $.post('/metrics', data);
  }

  return {
    'log': log,
    'get': function() { return g_log.slice(); },
    'reportMetric': reportMetric
  };
});
